<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: src/BillboardTransform.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_billboard_transform_8hpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">BillboardTransform.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_billboard_transform_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * eduRayTracer - An Educational Ray Tracing Software Package</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Contributor(s): Pedro Santana - ISCTE-IUL (2014-2016)</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#ifndef _H_BillboardTransform_</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#define _H_BillboardTransform_</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_mat_8hpp.html">Mat.hpp</a>&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_camera_8hpp.html">Camera.hpp</a>&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_transform_8hpp.html">Transform.hpp</a>&quot;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00017"></a><span class="lineno"><a class="line" href="class_billboard_transform.html">   17</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_billboard_transform.html">BillboardTransform</a> : <span class="keyword">public</span> <a class="code" href="class_transform.html">Transform</a> {</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <a class="code" href="class_mat.html">Mat</a> RX,RY,RZ,S,T;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="keywordtype">double</span> o_x,o_y,o_z;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keywordtype">bool</span> align_vertical;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="class_billboard_transform.html#affa244460a95e650ad6bf150c712774f">   31</a></span>&#160;    std::string <a class="code" href="class_billboard_transform.html#affa244460a95e650ad6bf150c712774f">uid</a>;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="class_billboard_transform.html#a366a92eed6cde6044379cc351b0134b7">   34</a></span>&#160;    <a class="code" href="class_camera.html">Camera</a>* <a class="code" href="class_billboard_transform.html#a366a92eed6cde6044379cc351b0134b7">camera</a>;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="class_billboard_transform.html#a91f2b43fe12af2a2912030fa67ffa040">   40</a></span>&#160;    <a class="code" href="class_billboard_transform.html#a91f2b43fe12af2a2912030fa67ffa040">BillboardTransform</a>() {align_vertical = <span class="keyword">true</span>;}</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    </div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <a class="code" href="class_billboard_transform.html#a91f2b43fe12af2a2912030fa67ffa040">BillboardTransform</a>(<span class="keywordtype">double</span> yaw, <span class="keywordtype">double</span> pitch, <span class="keywordtype">double</span> roll, <span class="keywordtype">double</span> dx, <span class="keywordtype">double</span> dy, <span class="keywordtype">double</span> dz, </div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;              <span class="keywordtype">double</span> scale_x, <span class="keywordtype">double</span> scale_y, <span class="keywordtype">double</span> scale_z, <a class="code" href="class_camera.html">Camera</a>* _camera);</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    </div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="class_billboard_transform.html#abe16851d9f9d2149ad81e21c7e0dac4a">update_global_tf</a>();</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="class_billboard_transform.html#abe16851d9f9d2149ad81e21c7e0dac4a">update_global_tf</a>(<a class="code" href="class_mat.html">Mat</a> &amp;current);</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div><div class="line"><a name="l00070"></a><span class="lineno"><a class="line" href="class_billboard_transform.html#a4d49ea1957972293f8c4c25e9c63141c">   70</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_billboard_transform.html#a4d49ea1957972293f8c4c25e9c63141c">setAlignVertical</a>(<span class="keywordtype">bool</span> _align){align_vertical = _align;}</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00076"></a><span class="lineno"><a class="line" href="class_billboard_transform.html#a064e3a5f3933b74ab225aec1ad45882e">   76</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_billboard_transform.html#a064e3a5f3933b74ab225aec1ad45882e">getAlignVertical</a>(){<span class="keywordflow">return</span> align_vertical;}</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;};</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="class_billboard_transform_html_abe16851d9f9d2149ad81e21c7e0dac4a"><div class="ttname"><a href="class_billboard_transform.html#abe16851d9f9d2149ad81e21c7e0dac4a">BillboardTransform::update_global_tf</a></div><div class="ttdeci">virtual void update_global_tf()</div><div class="ttdoc">Triggers the update of the global_tf transformation matrice. It should be invoked whenever camera cha...</div><div class="ttdef"><b>Definition:</b> BillboardTransform.cpp:27</div></div>
<div class="ttc" id="class_billboard_transform_html_a91f2b43fe12af2a2912030fa67ffa040"><div class="ttname"><a href="class_billboard_transform.html#a91f2b43fe12af2a2912030fa67ffa040">BillboardTransform::BillboardTransform</a></div><div class="ttdeci">BillboardTransform()</div><div class="ttdoc">A BillboardTransform constructor. Applying this Transform without further updates generates undefined...</div><div class="ttdef"><b>Definition:</b> BillboardTransform.hpp:40</div></div>
<div class="ttc" id="class_mat_html"><div class="ttname"><a href="class_mat.html">Mat</a></div><div class="ttdoc">A class to create and manipulate matrices. </div><div class="ttdef"><b>Definition:</b> Mat.hpp:13</div></div>
<div class="ttc" id="class_billboard_transform_html_affa244460a95e650ad6bf150c712774f"><div class="ttname"><a href="class_billboard_transform.html#affa244460a95e650ad6bf150c712774f">BillboardTransform::uid</a></div><div class="ttdeci">std::string uid</div><div class="ttdoc">A unique identififier for this transform. </div><div class="ttdef"><b>Definition:</b> BillboardTransform.hpp:31</div></div>
<div class="ttc" id="class_camera_html"><div class="ttname"><a href="class_camera.html">Camera</a></div><div class="ttdoc">A class to create and manipulate virtual projective cameras. </div><div class="ttdef"><b>Definition:</b> Camera.hpp:20</div></div>
<div class="ttc" id="class_billboard_transform_html_a064e3a5f3933b74ab225aec1ad45882e"><div class="ttname"><a href="class_billboard_transform.html#a064e3a5f3933b74ab225aec1ad45882e">BillboardTransform::getAlignVertical</a></div><div class="ttdeci">bool getAlignVertical()</div><div class="ttdoc">Return true if the billboard has been setup to be always vertically aligned (true by default) ...</div><div class="ttdef"><b>Definition:</b> BillboardTransform.hpp:76</div></div>
<div class="ttc" id="class_transform_html"><div class="ttname"><a href="class_transform.html">Transform</a></div><div class="ttdoc">A class to handle rigid transformations. </div><div class="ttdef"><b>Definition:</b> Transform.hpp:17</div></div>
<div class="ttc" id="class_billboard_transform_html_a366a92eed6cde6044379cc351b0134b7"><div class="ttname"><a href="class_billboard_transform.html#a366a92eed6cde6044379cc351b0134b7">BillboardTransform::camera</a></div><div class="ttdeci">Camera * camera</div><div class="ttdoc">A pointer to the camera. </div><div class="ttdef"><b>Definition:</b> BillboardTransform.hpp:34</div></div>
<div class="ttc" id="class_billboard_transform_html_a4d49ea1957972293f8c4c25e9c63141c"><div class="ttname"><a href="class_billboard_transform.html#a4d49ea1957972293f8c4c25e9c63141c">BillboardTransform::setAlignVertical</a></div><div class="ttdeci">void setAlignVertical(bool _align)</div><div class="ttdoc">State whether the billboard should always be vertically aligned (true by default) ...</div><div class="ttdef"><b>Definition:</b> BillboardTransform.hpp:70</div></div>
<div class="ttc" id="class_billboard_transform_html"><div class="ttname"><a href="class_billboard_transform.html">BillboardTransform</a></div><div class="ttdoc">A class to handle Billboard transformations. </div><div class="ttdef"><b>Definition:</b> BillboardTransform.hpp:17</div></div>
<div class="ttc" id="_transform_8hpp_html"><div class="ttname"><a href="_transform_8hpp.html">Transform.hpp</a></div></div>
<div class="ttc" id="_mat_8hpp_html"><div class="ttname"><a href="_mat_8hpp.html">Mat.hpp</a></div></div>
<div class="ttc" id="_camera_8hpp_html"><div class="ttname"><a href="_camera_8hpp.html">Camera.hpp</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="_billboard_transform_8hpp.html">BillboardTransform.hpp</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
